Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.batik.ext.awt.image.rendered
Class MorphologyOp

    java.lang.Object
      org.apache.batik.ext.awt.image.rendered.MorphologyOp

All Implemented Interfaces:
  BufferedImageOp, RasterOp

    public class MorphologyOp

extends Object
implements BufferedImageOp, RasterOp

This class provides an implementation for the SVG feMorphology filter, as defined in Chapter 15, section 20 of the SVG specification.

Constructor Summary
`MorphologyOp(int radiusX, int radiusY, boolean doDilation)`

Method Summary
`BufferedImage` | `createCompatibleDestImage(BufferedImage src, ColorModel destCM)`
`WritableRaster` | `createCompatibleDestRaster(Raster src)`
`BufferedImage` | `filter(BufferedImage src, BufferedImage dest)` This implementation of filter does the morphology operation on a premultiplied alpha image.
`WritableRaster` | `filter(Raster src, WritableRaster dest)` Filters src and writes result into dest.
`Rectangle2D` | `getBounds2D(BufferedImage src)`
`Rectangle2D` | `getBounds2D(Raster src)`
`Point2D` | `getPoint2D(Point2D srcPt, Point2D destPt)`
`RenderingHints` | `getRenderingHints()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MorphologyOp

    public MorphologyOp(int radiusX,
                        int radiusY,
                        boolean doDilation)

Parameters:
  `radiusX` - defines the radius of filter operation on X-axis. Should not be negative. A value of zero will disable the effect of the operation on X-axis, as described in the SVG specification.
  `radiusY` - defines the radius of filter operation on Y-axis. Should not be negative. A value of zero will disable the effect of the operation on Y-axis, as described in the SVG specification.
  `doDilation` - defines whether to do dilation or erosion operation. Will do dilation when the value is true, erosion when false.

Method Detail

### getBounds2D

    public Rectangle2D getBounds2D(Raster src)

  Specified by:
    `getBounds2D` in interface `RasterOp`

### getBounds2D

    public Rectangle2D getBounds2D(BufferedImage src)

  Specified by:
    `getBounds2D` in interface `BufferedImageOp`

### getPoint2D

    public Point2D getPoint2D(Point2D srcPt,
                              Point2D destPt)

  Specified by:
    `getPoint2D` in interface `BufferedImageOp`
  Specified by:
    `getPoint2D` in interface `RasterOp`

### getRenderingHints

    public RenderingHints getRenderingHints()

  Specified by:
    `getRenderingHints` in interface `BufferedImageOp`
  Specified by:
    `getRenderingHints` in interface `RasterOp`

### createCompatibleDestRaster

    public WritableRaster createCompatibleDestRaster(Raster src)

  Specified by:
    `createCompatibleDestRaster` in interface `RasterOp`

### createCompatibleDestImage

    public BufferedImage createCompatibleDestImage(BufferedImage src,
                                                   ColorModel destCM)

  Specified by:
    `createCompatibleDestImage` in interface `BufferedImageOp`

### filter

    public WritableRaster filter(Raster src,
                                 WritableRaster dest)

  Filters src and writes result into dest. If dest if null, then a Raster is created. If dest and src refer to the same object, then the source is modified.

  The filtering kernel(the operation range for each pixel) is a rectangle of width 2*radiusX+1 and height radiusY+1

  Specified by:
    `filter` in interface `RasterOp`
  Parameters:
    `src` - the Raster to be filtered
    `dest` - stores the filtered image. If null, a destination will be created. src and dest can refer to the same Raster, in which situation the src will be modified.

### filter

    public BufferedImage filter(BufferedImage src,
                                BufferedImage dest)

  This implementation of filter does the morphology operation on a premultiplied alpha image. This tends to muddy the colors. so something that is supposed to be a mostly transparent bright red may well become a muddy opaque red. Where as I think it should become a bright opaque red. Which is the result you would get if you were using unpremult data.

  Specified by:
    `filter` in interface `BufferedImageOp`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008 Apache Software Foundation. All Rights Reserved.